-- ToME - Tales of Maj'Eyal
-- Copyright (C) 2009, 2010, 2011, 2012 Nicolas Casalini
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Nicolas Casalini "DarkGod"
-- darkgod@te4.org



--We're loading this file after base ToME loads. It is going to re-define a portion of BtF, specifically 'activate'.
Talents.talents_def.T_BEYOND_THE_FLESH.activate = function(self, t)
	local tk = self:getInven("PSIONIC_FOCUS") and self:getInven("PSIONIC_FOCUS")[1]
		if not tk then return false end

		local ret = {name = self.name:capitalize().."'s "..t.name}
		if tk.type == "gem" then
			local power = (tk.material_level or 1) * 3 + math.ceil(self:callTalent(self.T_RESONANT_FOCUS, "bonus") / 5)
			self:talentTemporaryValue(ret, "inc_stats", {
				[self.STAT_STR] = power,
				[self.STAT_DEX] = power,
				[self.STAT_MAG] = power,
				[self.STAT_WIL] = power,
				[self.STAT_CUN] = power,
				[self.STAT_CON] = power,
			})
		elseif tk.subtype == "mindstar" then
			ret.mindstar_grab = {
				chance = (tk.material_level or 1) * 5 + 5 + self:callTalent(self.T_RESONANT_FOCUS, "bonus"),
				range = 2 + (tk.material_level or 1),
			}
		elseif tk.combat then
			self:talentTemporaryValue(ret, "psi_focus_combat", 1) -- enables Psi Focus attacks
		end
--No changes before here
		local weapon = self:getInven("MAINHAND") and self:getInven("MAINHAND")[1] or false -- this checks first to see if the actor has an item in the main hand and then sets the value to the id of the item if there is one, or sets the variable to false to avoid an error if there is no weapon in the mainhand
		local ammo = self:getInven("QUIVER") and self:getInven("QUIVER")[1] or false  -- does the same thing, but for ammo
		if weapon and weapon.subtype ~= "mindstar" and weapon.subtype ~= "shield" then -- checks weapon, shield check in case of foolishness/post 1.5 sw talents on 'venturers
			if weapon.subtype == "longbow" or weapon.subtype == "sling" or weapon.subtype == "steamgun" then -- checks to see if it's a launcher				
				if self:knowTalent(self.T_STRENGTH_OF_PURPOSE) then -- check for SoP
					if ammo  then -- we'll check all ammo's; if they have a dex mod then the damage will be better, otherwise it's still an accuracy check
						if self:getDex(100, true) < self:getCun(100, true) * (0.6 + self:callTalent(self.T_RESONANT_FOCUS, "bonus")/100) then -- checks stats for dex
							self:talentTemporaryValue(ret, "use_psi_combat", 1) -- Substitutes stats
						end
					end
				else
					if ammo and ammo.combat.dammod.str and ammo.combat.dammod.dex then -- checks ammo's modifiers
						if self:getStr(100, true) + self:getDex(100, true) < (self:getWil(100, true) + self:getCun(100, true)) * (0.6 + self:callTalent(self.T_RESONANT_FOCUS, "bonus")/100) then -- checks stats for str+dex
							self:talentTemporaryValue(ret, "use_psi_combat", 1) -- Substitutes stats
						end
					else 
						if ammo and ammo.combat.dammod.str and not ammo.combat.dammod.dex then 
							if self:getStr(100, true) < self:getWil(100, true) * (0.6 + self:callTalent(self.T_RESONANT_FOCUS, "bonus")/100) then -- checks stats for str
								self:talentTemporaryValue(ret, "use_psi_combat", 1) -- Substitutes stats
							end
						else 
							if ammo and ammo.combat.dammod.dex and not ammo.combat.dammod.str then 
								if self:getDex(100, true) < self:getCun(100, true) * (0.6 + self:callTalent(self.T_RESONANT_FOCUS, "bonus")/100) then -- checks stats for dex
									self:talentTemporaryValue(ret, "use_psi_combat", 1) -- Substitutes stats
								end
							end
						end
					end
				end
			else
				if self:knowTalent(self.T_STRENGTH_OF_PURPOSE) or self:knowTalent(self.T_LETHALITY) and weapon and weapon.subtype == "dagger" then -- check for SoP, also scoop up daggers if we know lethality to stop them getting caught in the str+dex check later
					if weapon then -- we'll check all weapons; if they have a dex mod then the damage will be better, otherwise it's still an accuracy check
						if self:getDex(100, true)< self:getCun(100, true) * (0.6 + self:callTalent(self.T_RESONANT_FOCUS, "bonus")/100) then -- checks stats for dex, bundles in dex vs cun accuracy check for staves.
							self:talentTemporaryValue(ret, "use_psi_combat", 1) -- Substitutes stats
						end
					end
				else 
					if weapon and weapon.combat.dammod.str and weapon.combat.dammod.dex then -- checks weapon's modifiers
						if self:getStr(100, true) + self:getDex(100, true) < (self:getWil(100, true) + self:getCun(100, true)) * (0.6 + self:callTalent(self.T_RESONANT_FOCUS, "bonus")/100) then -- checks stats for str+dex
							self:talentTemporaryValue(ret, "use_psi_combat", 1) -- Substitutes stats
						end
					else 
						if weapon and weapon.combat.dammod.str and not weapon.combat.dammod.dex then 
							if self:getStr(100, true) < self:getWil(100, true) * (0.6 + self:callTalent(self.T_RESONANT_FOCUS, "bonus")/100) then -- checks stats for str
								self:talentTemporaryValue(ret, "use_psi_combat", 1) -- Substitutes stats
							end
						else 
							if weapon and weapon.combat.dammod.dex and not weapon.combat.dammod.str or weapon and weapon.subtype == "staff" then 
								if self:getDex(100, true)< self:getCun(100, true) * (0.6 + self:callTalent(self.T_RESONANT_FOCUS, "bonus")/100) then -- checks stats for dex, bundles in dex vs cun accuracy check for staves.
									self:talentTemporaryValue(ret, "use_psi_combat", 1) -- Substitutes stats
								end
							end
						end
					end
				end
			end
		else
			if weapon and weapon.subtype == "shield" then -- Stone Warden check, becuase why not, I guess? Not really relevenat until after 1.5 when dorf 'venturers can use SW talents, but, whatever.
				if self:getStr(100, true) < self:getWil(100, true) * (0.6 + self:callTalent(self.T_RESONANT_FOCUS, "bonus")/100) then -- check stats for str
					self:talentTemporaryValue(ret, "use_psi_combat", 1) -- Substitutes stats
				end
			elseif not weapon and self:knowTalent(self.T_EMPTY_HAND) then -- checks for unarmed mastery if you don't have a mainhand weapon . elseif here to set up final else as catch-all, in case something wierd happens
				local hands = self:getInven("HANDS") and self:getInven("HANDS")[1] or false
				if hands and hands.wielder.combat.dammod then 
					if self:getStr(100, true) + self:getDex(100, true) < (self:getWil(100, true) + self:getCun(100, true)) * (0.6 + self:callTalent(self.T_RESONANT_FOCUS, "bonus")/100) then -- hand gear is not affected by SoP, so we don't have to worry about that here. there are no other non-addon talents that will change their dammods, so we're going to assume it uses the standard 40/40/40 and check for str+dex
						self:talentTemporaryValue(ret, "use_psi_combat", 1) -- Substitutes stats
					end
				end
			else
				self:talentTemporaryValue(ret, "use_psi_combat", 1)-- Substitutes stats
			end
		end
		game:onTickEnd(function()
			self:actorCheckSustains(true) end -- affects equipment for some talents
		)
		return ret
	end